defmodule Datasci.Application do
  @moduledoc false

  use Application

  # gdk note: I changed max_overflow from 2 to 0 in order to prevent cration
  # of more and more worker processes.

  defp poolboy_config do
    [
      name: {:local, :worker},
      worker_module: Datasci.Worker,
      size: 5,
      max_overflow: 0
    ]
  end

  def start(_type, args) do
    IO.inspect(args, label: "starting application datasci")
    children = [
      :poolboy.child_spec(:worker, poolboy_config())
    ]

    IO.inspect(children, label: "*** (Datasci.Application.start) children")

    opts = [strategy: :one_for_one, name: Datasci.Supervisor]
    Supervisor.start_link(children, opts)
  end
end

