defmodule Datasci.Test do
  @timeout 60000

  def start do
    [
      {"Data/iris.csv", "petal_length"},
      {"Data/iris.csv", "petal_width"},
      {"Data/iris.csv", "sepal_length"},
      {"Data/iris.csv", "sepal_width"},
      {"Data/penguins.csv", "bill_length_mm"},
      {"Data/penguins.csv", "bill_depth_mm"},
      {"Data/penguins.csv", "flipper_length_mm"},
      {"Data/penguins.csv", "body_mass_g"},
      {"Data/iris.csv", "petal_length"},
      {"Data/iris.csv", "petal_width"},
      {"Data/iris.csv", "sepal_length"},
      {"Data/iris.csv", "sepal_width"},
      {"Data/penguins.csv", "bill_length_mm"},
      {"Data/penguins.csv", "bill_depth_mm"},
      {"Data/penguins.csv", "flipper_length_mm"},
      {"Data/penguins.csv", "body_mass_g"},
      {"Data/iris.csv", "petal_length"},
      {"Data/iris.csv", "petal_width"},
      {"Data/iris.csv", "sepal_length"},
      {"Data/iris.csv", "sepal_width"},
      {"Data/penguins.csv", "bill_length_mm"},
      {"Data/penguins.csv", "bill_depth_mm"},
      {"Data/penguins.csv", "flipper_length_mm"},
      {"Data/penguins.csv", "body_mass_g"},
      {"Data/iris.csv", "petal_length"},
      {"Data/iris.csv", "petal_width"},
      {"Data/iris.csv", "sepal_length"},
      {"Data/iris.csv", "sepal_width"},
      {"Data/penguins.csv", "bill_length_mm"},
      {"Data/penguins.csv", "bill_depth_mm"},
      {"Data/penguins.csv", "flipper_length_mm"},
      {"Data/penguins.csv", "body_mass_g"},
      {"Data/iris.csv", "petal_length"},
      {"Data/iris.csv", "petal_width"},
      {"Data/iris.csv", "sepal_length"},
      {"Data/iris.csv", "sepal_width"},
      {"Data/penguins.csv", "bill_length_mm"},
      {"Data/penguins.csv", "bill_depth_mm"},
      {"Data/penguins.csv", "flipper_length_mm"},
      {"Data/penguins.csv", "body_mass_g"},
      {"Data/iris.csv", "petal_length"},
      {"Data/iris.csv", "petal_width"},
      {"Data/iris.csv", "sepal_length"},
      {"Data/iris.csv", "sepal_width"},
      {"Data/penguins.csv", "bill_length_mm"},
      {"Data/penguins.csv", "bill_depth_mm"},
      {"Data/penguins.csv", "flipper_length_mm"},
      {"Data/penguins.csv", "body_mass_g"},
    ]
    |> Enum.map(fn {data_set_path, column_name} ->
      async_call_calc_mean(data_set_path, column_name) end)
    |> Enum.with_index()
    |> Enum.each(fn {task, idx} -> await_and_inspect(task, idx) end)
  end

  def stop do
    {:ready, numworkers, _, _} = :poolboy.status(:worker)                            
    1 .. numworkers                                                                                                      
    |> Enum.each(fn num -> stop_worker(num) end)
  end

  defp async_call_calc_mean(data_set_path, column_name) do
    Task.async(fn ->
      :poolboy.transaction(
        :worker,
        fn pid -> GenServer.call(pid, {:calc_mean, data_set_path, column_name}) end,
        @timeout
      )
    end)
  end

  #defp await_and_inspect(task), do: task |> Task.await(@timeout) |> IO.inspect(label: "(async_call_calc_mean) result")
  defp await_and_inspect(task, idx) do
     response = task
    |> Task.await(@timeout)
    #|> IO.inspect(label: "(async_call_calc_mean) result")
    {:ok, ["ok", column, value]} = response
    IO.puts("#{idx + 1}. column: #{column}  value: #{value}")
  end

  def stop_worker(num) do
    IO.puts("(stop_worker) num: #{num}")
    Task.async(fn ->
      :poolboy.transaction(
        :worker,
        fn pid -> GenServer.stop(pid, :normal) end,
        @timeout
      )
    end)
  end

end
