
import os
#import time
import pandas as pd
import json
#from erlport.erlterms import Atom


DataSets = {}


def load_data_set(data_set_path):
    if data_set_path in DataSets:
        data_set = DataSets.get(data_set_path)
        #print(f'*** reusing {data_set_path}')
        return data_set
    else:
        if os.path.exists(data_set_path):
            data_set = pd.read_csv(data_set_path)
            DataSets[data_set_path] = data_set
            print(f'*** loading {data_set_path}')
            return data_set
        else:
            return None


def calc_mean(data_set_path, column_name):
    #time.sleep(1)
    data_set_path = data_set_path.decode()
    column_name = column_name.decode()
    data_set = load_data_set(data_set_path)
    if data_set is not None:
        if column_name in data_set.columns:
            mean = data_set[column_name].mean()
            result = ('ok', column_name, mean)
            json_result = json.dumps(result)
            return json_result
        else:
            msg = f'no column "{column_name}" in data-set "{data_set_path}"'
            result = ('error', msg)
            json_result = json.dumps(result)
            return json_result
    else:
        msg = f'cannot locate data-set "{data_set_path}"'
        result = ('error', msg)
        json_result = json.dumps(result)
        return json_result
